NXMapAddonMinimapNames = {		
    ["U1FrameMinimapButton"] = true,
    ["MinimapZoom"] = true,
	["GatherNote"] = true,
	["GatherMatePin"] = true,
	["MobMapMinimapDot_"] = true,
	["CartographerNotesPOI"] = true,
	["RecipeRadarMinimapIcon"] = true,
	["NauticusMiniIcon"] = true,
	["ZGVMarkerMini"] = true,			
}
NXCarboniteTitle = "CARBONITE"
if GetLocale() == "zhTW" or GetLocale() == "zhCN" then
    NXCarboniteTitle = "CARB网易有爱版"
    BINDING_NAME_NxMAPTOGORIGINAL		= "切换默认地图"
    BINDING_NAME_NxMAPTOGNORMMAX		= "切换地图(普通/最大化)"
    BINDING_NAME_NxMAPTOGNONEMAX		= "切换地图(最大化/关闭)"
    BINDING_NAME_NxMAPTOGNONENORM		= "切换地图(普通/关闭)"
    BINDING_NAME_NxMAPSCALERESTORE	    = "恢复地图缩放比例"
    BINDING_NAME_NxMAPTOGMINIFULL		= "切换全尺寸小地图"
    BINDING_NAME_NxMAPTOGHERB			= "显示或隐藏草点"
    BINDING_NAME_NxMAPTOGMINE			= "显示或隐藏矿点"
    BINDING_NAME_NxTOGGLEFAV			= "显示收藏记录"
    BINDING_NAME_NxTOGGLEGUIDE			= "显示百科指南"
    BINDING_NAME_NxTOGGLEWAREHOUSE	= "显示资产中心"
    BINDING_NAME_NxTOGGLEWATCHMINI	= "任务跟踪窗口最小化/还原"
    BINDING_NAME_NxWATCHUSEITEM		= "使用列出的第一个任务物品"
    BINDING_NAME_NxMAPSKIPTARGET		= "跳过当前路径的目的地"
    NXLOADING			= "加载中.."
    NXLOAD_DONE			= "已载入"
    NXlARTIFACTS		= "考古碎片"
    NXlGas				= "气体"
    NXlEXTRACTGAS		= "气体微粒"
    NXlFISHING			= "鱼场"
    NXlHERBGATHERING	= "草药点"
    NXlINCONFLICT		= "冲突"
    NXlLEVELSPC			= "等级 "
    NXlMINING			= "矿点"
    NXlOpening			= "开启"
    NXlOpeningNoText	= "开启 - 无文字"
    NXlGLOWCAP			= "白闪菇"
    NXlEverfrost		= "冰冻薄片"
    NXlRiding			= "骑乘"
    NXlDurPattern = "^"..string.gsub(DURABILITY_TEMPLATE, "%%d", "(%%d+)")
    NXTravel = {
        ["Portal to "] = "→传送→ ",
        ["Boat to "] = "→渡船→ ",
        ["Zeppelin to "] = "→飞艇→ ",
        ["Tram to "] = "→地铁→ ",
    }
    
    NXlConflictMapName = {
        
    }
    NXlClassLocToCap = {
        ["死亡骑士"] = "DEATHKNIGHT",
        ["德鲁伊"] = "DRUID",
        ["猎人"] = "HUNTER",
        ["法师"] = "MAGE",
        ["圣骑士"] = "PALADIN",
        ["牧师"] = "PRIEST",
        ["潜行者"] = "ROGUE",
        ["萨满法师"] = "SHAMAN",
        ["术士"] = "WARLOCK",
        ["战士"] = "WARRIOR",
        ["武僧"] = "MONK",
    }
    NXlBGMessages = {  
        "敌人要进攻这里", "敌方要进攻",
        "这里安全", "这里安全",
        "来这里帮忙", "这里需要帮忙",
        "进攻此处", "来攻打",
        "防守此处", "来防守",
        "防住了", "防住了",
        "要丢了", "马上要丢掉",
    }
    NXlBGStatus = "报告状态"
    NXlItemTypes = {
        ARMOR,
        "消耗品",
        "容器",
        "宝石",
        "雕文",
        "钥匙",
        "其他",
        "弹药",
        "任務",
        "箭袋",
        "施法材料",
        "配方",
        "商品",
        "武器",
    }
    
    NXlMapNames = {
        ["Alliance"] = "联盟",
        ["Horde"] = "部落",
        ["Unknown Zone"] = "未知区域",
        ["Dalaran Underbelly"] = "达拉然下层",
        ["Cleft Shadow"] = "暗影裂口",
        ["Shrine of Seven Stars L2"] = NX_MAP_DATA.MAPS[905].."上层",
        ["Shrine of Two Moons L2"] = NX_MAP_DATA.MAPS[903].."上层",
    }
    if GetLocale() == "zhTW" then
        NXlBGMessages = {  
            "敵人要進攻這裡", "敵方要進攻",
            "這裡安全", "這裡安全",
            "來這裡幫忙", "這裡需要幫忙",
            "進攻此處", "來攻打",
            "防守此處", "來防守",
            "防住了", "防住了",
            "要丟了", "馬上要丟掉",
        }
        NXlGatherNames={
          ["Adamantite Deposit"]="堅鋼礦床",
          ["Adder's Tongue"]="奎蛇之舌",
          ["Ancient Gem Vein"]="上古宝石矿脉",
          ["Ancient Lichen"]="古老青苔",
          ["Arthas' Tears"]="阿薩斯之淚",
          ["Artifact"]="考古碎片",
          ["Azshara's Veil"]="艾薩拉的帷紗",
          ["Black Lotus"]="黑蓮花",
          ["Blindweed"]="盲目草",
          ["Bloodthistle"]="血薊",
          ["Briarthorn"]="石南草",
          ["Bruiseweed"]="跌打草",
          ["Cinderbloom"]="燼花",
          ["Cobalt Deposit"]="鈷藍礦床",
          ["Copper Vein"]="銅礦脈",
          ["Dark Iron Deposit"]="黑鐵礦床",
          ["Dragon's Teeth"]="龍之牙",
          ["Dreamfoil"]="夢葉草",
          ["Dreaming Glory"]="譽夢草",
          ["Earthroot"]="地根草",
          ["Elementium Vein"]="源質礦脈",
          ["Everfrost Chip"]="永霜屑片",
          ["Fadeleaf"]="枯葉草",
          ["Fel Iron Deposit"]="魔鐵礦床",
          ["Felweed"]="魔獄草",
          ["Firebloom"]="火焰花",
          ["Firethorn"]="火棘",
          ["Flame Cap"]="火帽花",
          ["Fool's Cap"]="丑帽菇",
          ["Frost Lotus"]="冰霜蓮花",
          ["Frozen Herb"]="冰凍草藥",
          ["Gas"]="气体",
          ["Ghost Iron Deposit"]="鬼鐵礦床",
          ["Ghost Mushroom"]="鬼魂菇",
          ["Glowcap"]="白閃菇",
          ["Gold Vein"]="金礦脈",
          ["Goldclover"]="金黃苜蓿",
          ["Golden Lotus"]="黃金蓮",
          ["Golden Sansam"]="黃金蔘",
          ["Goldthorn"]="金棘草",
          ["Grave Moss"]="墓地苔",
          ["Green Tea Leaf"]="綠茶葉",
          ["Gromsblood"]="格羅姆之血",
          ["Heartblossom"]="心綻花",
          ["Icecap"]="冰蓋草",
          ["Icethorn"]="冰棘",
          ["Incendicite Mineral Vein"]="火岩礦脈",
          ["Indurium Mineral Vein"]="精鐵礦脈",
          ["Iron Deposit"]="鐵礦床",
          ["Khadgar's Whisker"]="卡德加的鬍鬚",
          ["Khorium Vein"]="克銀礦脈",
          ["Kingsblood"]="皇血草",
          ["Kyparite Deposit"]="奇帕利礦床",
          ["Large Obsidian Chunk"]="大黑曜石塊",
          ["Lesser Bloodstone Deposit"]="次級血石礦床",
          ["Lichbloom"]="低語藤",
          ["Liferoot"]="活根草",
          ["Mageroyal"]="魔皇草",
          ["Mana Thistle"]="法力薊",
          ["Mithril Deposit"]="秘銀礦床",
          ["Mountain Silversage"]="山鼠草",
          ["Netherbloom"]="虛空花",
          ["Nethercite Deposit"]="虛空聚晶礦床",
          ["Netherdust Bush"]="虛空之塵灌木",
          ["Nightmare Vine"]="夢魘根",
          ["Obsidium Deposit"]="黑曜石塊",
          ["Peacebloom"]="寧神花",
          ["Purple Lotus"]="紫蓮花",
          ["Pyrite Deposit"]="黃鐵礦床",
          ["Ragveil"]="拉格維花",
          ["Rain Poppy"]="雨罌粟",
          ["Rich Adamantite Deposit"]="豐沃的堅鋼礦床",
          ["Rich Cobalt Deposit"]="豐沃的鈷藍礦床",
          ["Rich Elementium Vein"]="豐沃的源質礦脈",
          ["Rich Ghost Iron Deposit"]="豐沃的鬼鐵礦脈",
          ["Rich Kyparite Deposit"]="豐沃的奇帕利礦床",
          ["Rich Obsidium Deposit"]="豐沃的黑曜石塊",
          ["Rich Pyrite Deposit"]="豐沃的黃鐵礦床",
          ["Rich Saronite Deposit"]="豐沃的薩鋼礦床",
          ["Rich Thorium Vein"]="富瑟銀礦脈",
          ["Rich Trillium Vein"]="豐沃的延齡礦脈",
          ["Saronite Deposit"]="薩鋼礦床",
          ["Sha-Touched Herb"]="被污染的草藥",
          ["Silkweed"]="絲草",
          ["Silver Vein"]="銀礦脈",
          ["Silverleaf"]="銀葉草",
          ["Small Obsidian Chunk"]="小黑曜石塊",
          ["Small Thorium Vein"]="瑟銀礦脈",
          ["Snow Lily"]="雪百合",
          ["Sorrowmoss"]="悲傷苔蘚",
          ["Stormvine"]="風暴藤",
          ["Stranglekelp"]="荊棘藻",
          ["Sungrass"]="太陽草",
          ["Talandra's Rose"]="泰蘭卓的玫瑰",
          ["Terocone"]="泰魯草",
          ["Tiger Lily"]="虎百合",
          ["Tin Vein"]="錫礦脈",
          ["Titanium Vein"]="泰坦鋼礦脈",
          ["Trillium Vein"]="延齡礦脈",
          ["Truesilver Deposit"]="真銀礦床",
          ["Twilight Jasmine"]="暮光茉莉",
          ["Whiptail"]="鞭尾蜥草",
          ["Wild Steelbloom"]="野鋼花",
        }
    else
        NXlGatherNames={
          ["Adamantite Deposit"]="精金矿脉",
          ["Adder's Tongue"]="蛇信草",
          ["Ancient Gem Vein"]="上古宝石矿脉",
          ["Ancient Lichen"]="远古苔",
          ["Arthas' Tears"]="阿尔萨斯之泪",
          ["Artifact"]="考古碎片",
          ["Azshara's Veil"]="艾萨拉雾菇",
          ["Black Lotus"]="黑莲花",
          ["Blindweed"]="盲目草",
          ["Bloodthistle"]="血蓟",
          ["Briarthorn"]="石南草",
          ["Bruiseweed"]="跌打草",
          ["Cinderbloom"]="燃烬草",
          ["Cobalt Deposit"]="钴矿脉",
          ["Copper Vein"]="铜矿",
          ["Dark Iron Deposit"]="黑铁矿脉",
          ["Dragon's Teeth"]="龙齿草",
          ["Dreamfoil"]="梦叶草",
          ["Dreaming Glory"]="梦露花",
          ["Earthroot"]="地根草",
          ["Elementium Vein"]="源质矿",
          ["Everfrost Chip"]="永冻薄片",
          ["Fadeleaf"]="枯叶草",
          ["Fel Iron Deposit"]="魔铁矿脉",
          ["Felweed"]="魔草",
          ["Firebloom"]="火焰花",
          ["Firethorn"]="火棘花",
          ["Flame Cap"]="烈焰菇",
          ["Fool's Cap"]="愚人菇",
          ["Frost Lotus"]="雪莲花",
          ["Frozen Herb"]="冰冷的草药",
          ["Gas"]="气体",
          ["Ghost Iron Deposit"]="幽冥铁矿脉",
          ["Ghost Mushroom"]="幽灵菇",
          ["Glowcap"]="亮顶蘑菇",
          ["Gold Vein"]="金矿石",
          ["Goldclover"]="金苜蓿",
          ["Golden Lotus"]="黄金莲",
          ["Golden Sansam"]="黄金参",
          ["Goldthorn"]="金棘草",
          ["Grave Moss"]="墓地苔",
          ["Green Tea Leaf"]="绿茶叶",
          ["Gromsblood"]="格罗姆之血",
          ["Heartblossom"]="心灵之花",
          ["Icecap"]="冰盖草",
          ["Icethorn"]="冰棘草",
          ["Incendicite Mineral Vein"]="火岩矿脉",
          ["Indurium Mineral Vein"]="精铁矿脉",
          ["Iron Deposit"]="铁矿石",
          ["Khadgar's Whisker"]="卡德加的胡须",
          ["Khorium Vein"]="氪金矿脉",
          ["Kingsblood"]="皇血草",
          ["Kyparite Deposit"]="凯帕琥珀矿脉",
          ["Large Obsidian Chunk"]="大块黑曜石碎片",
          ["Lesser Bloodstone Deposit"]="次级血石矿脉",
          ["Lichbloom"]="巫妖花",
          ["Liferoot"]="活根草",
          ["Mageroyal"]="魔皇草",
          ["Mana Thistle"]="法力蓟",
          ["Mithril Deposit"]="秘银矿脉",
          ["Mountain Silversage"]="山鼠草",
          ["Netherbloom"]="虚空花",
          ["Nethercite Deposit"]="虚空矿脉",
          ["Netherdust Bush"]="灵尘灌木丛",
          ["Nightmare Vine"]="噩梦藤",
          ["Obsidium Deposit"]="黑曜石碎块",
          ["Peacebloom"]="宁神花",
          ["Purple Lotus"]="紫莲花",
          ["Pyrite Deposit"]="燃铁矿脉",
          ["Ragveil"]="邪雾草",
          ["Rain Poppy"]="雨粟花",
          ["Rich Adamantite Deposit"]="富精金矿脉",
          ["Rich Cobalt Deposit"]="富钴矿脉",
          ["Rich Elementium Vein"]="富源质矿",
          ["Rich Ghost Iron Deposit"]="富幽冥铁矿脉",
          ["Rich Kyparite Deposit"]="富凯帕琥珀矿脉",
          ["Rich Obsidium Deposit"]="巨型黑曜石石板",
          ["Rich Pyrite Deposit"]="富燃铁矿脉",
          ["Rich Saronite Deposit"]="富萨隆邪铁矿脉",
          ["Rich Thorium Vein"]="富瑟银矿",
          ["Rich Trillium Vein"]="富延极矿脉",
          ["Saronite Deposit"]="萨隆邪铁矿脉",
          ["Sha-Touched Herb"]="染煞草药",
          ["Silkweed"]="柔丝草",
          ["Silver Vein"]="银矿",
          ["Silverleaf"]="银叶草",
          ["Small Obsidian Chunk"]="小型黑曜石碎块",
          ["Small Thorium Vein"]="瑟银矿脉",
          ["Snow Lily"]="雪百合",
          ["Sorrowmoss"]="哀伤苔",
          ["Stormvine"]="风暴藤",
          ["Stranglekelp"]="荆棘藻",
          ["Sungrass"]="太阳草",
          ["Talandra's Rose"]="塔兰德拉的玫瑰",
          ["Terocone"]="泰罗果",
          ["Tiger Lily"]="卷丹",
          ["Tin Vein"]="锡矿",
          ["Titanium Vein"]="泰坦神铁矿脉",
          ["Trillium Vein"]="延极矿脉",
          ["Truesilver Deposit"]="真银矿石",
          ["Twilight Jasmine"]="暮光茉莉",
          ["Whiptail"]="鞭尾草",
          ["Wild Steelbloom"]="野钢花",
        }
    end
else	
	BINDING_NAME_NxMAPTOGORIGINAL		= "Toggle Original Map"
	BINDING_NAME_NxMAPTOGNORMMAX		= "Toggle Normal or Max Map"
	BINDING_NAME_NxMAPTOGNONEMAX		= "Toggle None or Max Map"
	BINDING_NAME_NxMAPTOGNONENORM		= "Toggle None or Normal Map"
	BINDING_NAME_NxMAPSCALERESTORE	= "Restore Saved Map Scale"
	BINDING_NAME_NxMAPTOGMINIFULL		= "Toggle Full Size Minimap"
	BINDING_NAME_NxMAPTOGHERB			= "Toggle Herbs on map"
	BINDING_NAME_NxMAPTOGMINE			= "Toggle Mining on map"
	BINDING_NAME_NxTOGGLEFAV			= "Toggle Favorites"
	BINDING_NAME_NxTOGGLEGUIDE			= "Toggle Guide"
	BINDING_NAME_NxTOGGLEWAREHOUSE	= "Toggle Warehouse"
	BINDING_NAME_NxTOGGLEWATCHMINI	= "Toggle Watch List Minimize"
	BINDING_NAME_NxWATCHUSEITEM		= "Use Top Quest Watch Item"
	BINDING_NAME_NxMAPSKIPTARGET		= "Skip Current Target"
	NXLOADING			= "loading"
	NXLOAD_DONE			= "load done"
	NXlARTIFACTS		= "Searching for Artifacts"
	NXlGas				= "Gas"
	NXlEXTRACTGAS		= "Extract Gas"
	NXlFISHING			= "Fishing"
	NXlHERBGATHERING	= "Herb Gathering"
	NXlINCONFLICT		= "In Conflict"
	NXlLEVELSPC			= "Level "
	NXlMINING			= "Mining"
	NXlOpening			= "Opening"
	NXlOpeningNoText	= "Opening - No Text"
	NXlGLOWCAP			= "Glowcap"
	NXlEverfrost		= "Everfrost Chip"
	NXlRiding			= "Riding"
	NXlDurPattern = "^Durability (%d+) / (%d+)"
    NXTravel = {
    }
	NXlClassLocToCap = {		
		["Death Knight"] = "DEATHKNIGHT",
		["Druid"] = "DRUID",
		["Hunter"] = "HUNTER",
		["Mage"] = "MAGE",
		["Paladin"] = "PALADIN",
		["Priest"] = "PRIEST",
		["Rogue"] = "ROGUE",
		["Shaman"] = "SHAMAN",
		["Warlock"] = "WARLOCK",
		["Warrior"] = "WARRIOR",
	}
	NXlBGMessages = {		
		"Incoming", "Inc",
		"Clear", "Clear",
		"Help", "Help",
		"Attack", "Attack",
		"Guard", "Guard",
		"Well Defended", "Well Defended",
		"Losing", "Losing",
	}
	NXlBGStatus			= "Report Status"
	NXlItemTypes = {
		ARMOR,
		"Consumable",
		"Container",
		"Gem",
		"Glyph",
		"Key",
		"Miscellaneous",
		"Projectile",
		"Quest",
		"Quiver",
		"Reagent",
		"Recipe",
		"Trade Goods",
		"Weapon",
	}
	NXlMapNames = {	
	}
	NXlMapSubNames = {
		["Dalaran"] = {
			["Cantrips & Crows"] = 2,
			["Circle of Wills"] = 2,
			["The Black Market"] = 2,
			["The Underbelly"] = 2,
		}
	}
    NXlGatherNames = {}
end
