local L, _TRANS, CreateFrame, hooksecurefunc, getreplacehook = unpack((select(2, ...)).locals)
function Nx.Sec:Start()
	Nx.Timer:Start (0, .1, self, self.ValidateTime)
end
function Nx.Sec:ValidateTime()
	local dt = self:Date()
	local x = 131231
	if dt >= x then
		Nx.Timer:Start (-1, 0, self, self.OldMsg)
	end
	Nx.Timer:Start (0, 0, self, self.Validate)	
	return .1
end
function Nx.Sec:Date()
	local w,m,d,y = CalendarGetDate()
	y = y - 2000
	return y*10000+m*100+d
end
function Nx.Sec:OldMsg()
	local s = L"\n|cffff4040This version is pretty old.\n|rVisit |cff40ff40" .. Nx.WebSite .. L"|r and check for a newer version."
	Nx.prt (s)
end
function Nx.Sec:Validate()
	self:Unlock()
	self.Validate = nil	
end
function Nx.Sec:Unlock()
	local Nx = Nx
	local function func()
		Nx.Fav.ToggleShow = function (self) Nx.Fav.ToggleShow_(self) end
		if Nx.Info then
			Nx.Info.Update = function (self) Nx.Info.Update_(self) end
		end
		Nx.Map.Guide.ToggleShow = function (self) Nx.Map.Guide.ToggleShow_(self) end
		Nx.Quest.List.Update = function (self) Nx.Quest.List.Update_(self) end
		Nx.Quest.Watch.Update = function (self) Nx.Quest.Watch.Update_(self) end
		Nx.Social.List.Update = function (self) self:Update_() end
		Nx.Warehouse.ToggleShow = function (self) Nx.Warehouse.ToggleShow_(self) end
	end
	
	func()
	Nx.Help.Demo:StartOnce()
	self.Unlock = nil		
end
